include:
  - project: coscine/tools/gitlab-ci-templates
    file: 
      - /docker-runner.yml
      - /nodejs.yml
  - template: Code-Quality.gitlab-ci.yml
  - template: Security/SAST.gitlab-ci.yml
  - template: Security/Secret-Detection.gitlab-ci.yml
  - template: Security/Dependency-Scanning.gitlab-ci.yml

stages:
  - build
  - test
  - publish
  - pages
  - code-analysis

build-branch:
  extends: .build-branch

build-npm-release:
  extends: .build-npm-release

test:
  extends: .test

publish-gitlab:
  extends: .publish-gitlab-release

pages:
  extends: .pages
  when: manual

code_quality:
  stage: code-analysis
  tags:
    - runner:docker-privileged
  artifacts:
    paths: [gl-code-quality-report.json]

sast:
  stage: code-analysis
  tags:
    - runner:docker
  artifacts:
    reports:
      sast: gl-sast-report.json

dependency_scanning:
  stage: code-analysis
  tags:
    - runner:docker

secret_detection:
  stage: code-analysis
  tags:
    - runner:docker
